set optbgcol {#D9D9D9 #AAEFEF #FFCCFF #FFFFCC #FFBBBB #D7D7F7 #AAEECC #FFE5E5 #CCEEAA #EEAACC #FFEF9A}
set optcanbgcol {#EEEEEE #EEFFFF #FFEEFF #FFFFEE #FFEEEE #E0EFFF #D0FFD0 #FFEFEF #FFFFE0 #FFE0EF #FFFFCC}
set optfgcol {#000000 #006666 #660066 #666600 #660000 #003366 #006633 #330066 #336600 #660033 #663300}
keylset optcolschemes Custom {{bg ""} {fg ""}}
keylset optcolschemes Default {{bg #D9D9D9} {fg #000000}}
keylset optcolschemes Cyan {{bg #AAEFEF} {fg #006666}}
keylset optcolschemes Magenta {{bg #FFCCFF} {fg #660066}}
keylset optcolschemes Yellow {{bg #FFFFCC} {fg #666600}}
keylset optcolschemes Red {{bg #FFBBBB} {fg #660000}}
keylset optcolschemes Blue {{bg #D7D7F7} {fg #006699}}
keylset optcolschemes Green {{bg #AAEECC} {fg #006633}}
keylset optcolschemes Pink {{bg #FFE5E5} {fg #330066}}
keylset optcolschemes Yellow-Green {{bg #CCEEAA} {fg #336600}}
keylset optcolschemes Purple {{bg #EEAACC} {fg #660033}}
keylset optcolschemes Brown {{bg #FFEF9A} {fg #663300}}





proc _optionColMenu {w varName listcol}\
{
    	upvar #0 $varName var
    	if {![info exists var]} \
	{
		set var [lindex $listcol 0]
    	}
    	menubutton $w -indicatoron 0 -menu $w.menu -text "      "\
		-background $var -activebackground $var \
	    	-relief raised -bd 2 -highlightthickness 2
    	menu $w.menu -tearoff 0
    	foreach i $listcol \
	{
		$w.menu add command -label "      " \
			-background $i -activebackground $i \
			-command "set $varName $i
			$w configure -background $i
			$w configure -activebackground $i
			set colschemes Custom"
    	}
    	return $w.menu
}

proc _optColorSchemes {w varName listschemes} \
{
    	upvar #0 $varName var
	global bgcol fgcol optbgcol optfgcol optcolschemes j

    	if {![info exists var]}\
	{
		set var [lindex $listschemes 0]
    	}
    	menubutton $w -textvariable $varName -indicatoron 0 -menu $w.menu \
	    	-relief raised -bd 2 -width 13 -highlightthickness 2
    	menu $w.menu -tearoff 0
    	foreach i $listschemes \
	{
		$w.menu add command -label $i -command "
			set $varName $i
			set bgcol [keylget optcolschemes $i.bg]
			set fgcol [keylget optcolschemes $i.fg]
			catch {.configure.top.lt1 configure -background \
				[keylget optcolschemes $i.bg] \
				-activebackground [keylget optcolschemes $i.bg]}
			catch {.configure.top.lt2 configure -background \
				[keylget optcolschemes $i.fg] \
				-activebackground \
				[keylget optcolschemes $i.fg]}"
    	}
    	return $w.menu
}
proc _changePalette {bgcol fgcol}\
{
	tk_setPalette background $bgcol foreground $fgcol
	global optbgcol optcanbgcol canbgcol listwindows
	set j 0
	foreach i $optbgcol \
	{
		if {[regexp $bgcol $i]}\
		{	set k $j
		}
		incr j
	}
	set canbgcol [lindex $optcanbgcol $k]
	.center.icons.can configure -background $canbgcol
	.center.tree.can configure -background $canbgcol
	foreach key [keylget listwindows]\
	{	.win$key.icons.can configure \
			-background $canbgcol
	}
}


proc _Dconfigure {id c}\
{
	if {[winfo exists .configure]}\
	{	catch {destroy .configure
			destroy .configicon}
	}
	global optcolschemes optbgcol optfgcol optactbgcol bgcol fgcol
	toplevel .configure -cursor top_left_arrow
	wm geometry .configure +100+100
	wm title .configure "Confirmation"
		toplevel .configicon
		label .configicon.img -image about
		pack .configicon.img
		wm iconwindow .configure .configicon
	frame .configure.top
	pack .configure.top -side top
	label .configure.top.lb1 -text "Background color"
	grid configure .configure.top.lb1 -row 1 -column 1
	_optionColMenu .configure.top.lt1 bgcol $optbgcol
	grid configure .configure.top.lt1 -row 1 -column 2
	label .configure.top.lb2 -text "Foreground color"
	grid configure .configure.top.lb2 -row 2 -column 1
	_optionColMenu .configure.top.lt2 fgcol $optfgcol
	grid configure .configure.top.lt2 -row 2 -column 2
	label .configure.top.lb3 -text "Color schemes   "
	grid configure .configure.top.lb3 -row 3 -column 1
	_optColorSchemes .configure.top.lt3 colschemes [keylget optcolschemes]
	grid configure .configure.top.lt3 -row 3 -column 2
	frame .configure.but
	pack .configure.but -side bottom
	button .configure.but.apply -text "Apply" -command \
	{	_changePalette $bgcol $fgcol
	}
	grid configure .configure.but.apply -row 1 -column 1
	button .configure.but.ok -text "OK" -command \
	{	
		catch {destroy .configure
			destroy .configicon}
		_changePalette $bgcol $fgcol
	}
	grid configure .configure.but.ok -row 1 -column 2
	button .configure.but.cancel -text "Cancel" -command \
	{	
		catch {destroy .configure
			destroy .configicon}
	}
	grid configure .configure.but.cancel -row 1 -column 3
	bind .configure <Return> "
		.configure.but.ok invoke
	"

}


proc _Dconfigure2 {id c}\
{
	global canbgcol listwindows oldcol
	set oldcol [lindex [. configure -background] 4]
	if {[winfo exists .configure]}\
	{	catch {destroy .configure
			destroy .configicon}
	}
	global optcolschemes optbgcol optfgcol optactbgcol bgcol fgcol
	toplevel .configure -cursor top_left_arrow
	wm geometry .configure +100+100
	wm protocol .configure WM_DELETE_WINDOW "catch {destroy .configure
						destroy .configicon}"
	wm title .configure "Colors"
		toplevel .configicon
		label .configicon.img -image about
		pack .configicon.img
		wm iconwindow .configure .configicon
	frame .configure.but
	pack .configure.but -side bottom
	frame .configure.top
	pack .configure.top -side top -expand yes -fill both

	label .configure.top.tx -text "Double-click to view"
	pack .configure.top.tx -side top

	scrollbar .configure.top.scroll -command ".configure.top.list yview"
	pack .configure.top.scroll -side right -fill y
	listbox .configure.top.list -yscroll ".configure.top.scroll set" \
		-background $canbgcol -width 20 -height 16 -setgrid 1
	pack .configure.top.list -side left -fill both -expand yes

	bind .configure.top.list <Double-1> \
		{
    			tk_setPalette [selection get]
			set q [lindex [.center.icons.buttons.home \
				configure -activebackground] 4]
			.center.icons.can configure -background $q
			.center.tree.can configure -background $q
			foreach key [keylget listwindows]\
			{	.win$key.icons.can configure -background $q
			}
			set canbgcol $q
			.configure.top.list configure -background $q
		}
	.configure.top.list insert 0 gray70 gray80 gray85 gray90 gray95 \
    		snow1 snow2 snow3 seashell1 seashell2 \
    		seashell3 AntiqueWhite1 AntiqueWhite2 AntiqueWhite3 \
    		bisque1 bisque2 bisque3 PeachPuff1 \
    		PeachPuff2 PeachPuff3 NavajoWhite1 NavajoWhite2 \
    		NavajoWhite3 LemonChiffon1 LemonChiffon2 \
    		LemonChiffon3 LemonChiffon4 cornsilk1 cornsilk2 cornsilk3 \
    		ivory1 ivory2 ivory3 honeydew1 honeydew2 \
    		honeydew3 LavenderBlush1 LavenderBlush2 \
    		LavenderBlush3 MistyRose1 MistyRose2 \
    		MistyRose3 azure1 azure2 azure3 \
    		SlateBlue1 SlateBlue2 SlateBlue3 RoyalBlue1 \
    		RoyalBlue2 RoyalBlue3 blue1 blue2 blue3 blue4 \
    		DodgerBlue1 DodgerBlue2 DodgerBlue3 SteelBlue1 \
    		SteelBlue2 SteelBlue3 DeepSkyBlue1 DeepSkyBlue2 \
    		DeepSkyBlue3 SkyBlue1 SkyBlue2 SkyBlue3 \
    		LightSkyBlue1 LightSkyBlue2 LightSkyBlue3 \
    		SlateGray1 SlateGray2 SlateGray3 \
    		LightSteelBlue1 LightSteelBlue2 LightSteelBlue3 \
    		LightBlue1 LightBlue2 LightBlue3 \
    		LightCyan1 LightCyan2 LightCyan3 \
    		PaleTurquoise1 PaleTurquoise2 PaleTurquoise3 \
    		CadetBlue1 CadetBlue2 CadetBlue3 turquoise1 \
    		turquoise2 turquoise3 cyan1 cyan2 cyan3 \
    		DarkSlateGray1 DarkSlateGray2 DarkSlateGray3 \
    		aquamarine1 aquamarine2 aquamarine3 \
    		DarkSeaGreen1 DarkSeaGreen2 DarkSeaGreen3 \
    		SeaGreen1 SeaGreen2 SeaGreen3 \
    		PaleGreen1 PaleGreen2 PaleGreen3 SpringGreen1 \
    		SpringGreen2 SpringGreen3 green1 green2 \
    		green3 chartreuse1 chartreuse2 chartreuse3 \
    		OliveDrab1 OliveDrab2 OliveDrab3 \
    		DarkOliveGreen1 DarkOliveGreen2 DarkOliveGreen3 \
    		khaki1 khaki2 khaki3 \
    		LightGoldenrod1 LightGoldenrod2 LightGoldenrod3 \
    		LightYellow1 LightYellow2 LightYellow3 \
    		yellow1 yellow2 yellow3 gold1 gold2 \
    		gold3 goldenrod1 goldenrod2 goldenrod3 \
    		DarkGoldenrod1 DarkGoldenrod2 DarkGoldenrod3 \
    		RosyBrown1 RosyBrown2 RosyBrown3 IndianRed1 \
    		IndianRed2 IndianRed3 sienna1 sienna2 sienna3 \
    		burlywood1 burlywood2 burlywood3 wheat1 \
    		wheat2 wheat3 tan1 tan2 tan3 chocolate1 \
    		chocolate2 chocolate3 firebrick1 firebrick2 \
    		firebrick3 brown1 brown2 brown3 salmon1 \
    		salmon2 salmon3 LightSalmon1 LightSalmon2 \
    		LightSalmon3 orange1 orange2 orange3 \
    		DarkOrange1 DarkOrange2 DarkOrange3 coral1 \
    		coral2 coral3 tomato1 tomato2 tomato3 \
    		OrangeRed1 OrangeRed2 OrangeRed3 red1 red2 red3 \
    		DeepPink1 DeepPink2 DeepPink3 HotPink1 \
    		HotPink2 HotPink3 pink1 pink2 pink3 \
    		LightPink1 LightPink2 LightPink3 PaleVioletRed1 \
    		PaleVioletRed2 PaleVioletRed3 maroon1 \
    		maroon2 maroon3 VioletRed1 VioletRed2 VioletRed3 \
    		magenta1 magenta2 magenta3 orchid1 \
    		orchid2 orchid3 plum1 plum2 plum3 \
    		MediumOrchid1 MediumOrchid2 MediumOrchid3 \
    		DarkOrchid1 DarkOrchid2 DarkOrchid3 purple1 \
    		purple2 purple3 MediumPurple1 MediumPurple2 \
    		MediumPurple3 thistle1 thistle2 thistle3
	button .configure.but.ok -text "OK" -command \
	{	
		catch {destroy .configure
			destroy .configicon}
	}
	grid configure .configure.but.ok -row 1 -column 1
	button .configure.but.cancel -text "Cancel" -command \
	{	
		catch {destroy .configure
			destroy .configicon}
    			tk_setPalette $oldcol
			set q [lindex [.center.icons.buttons.home \
				configure -activebackground] 4]
			.center.icons.can configure -background $q
			.center.tree.can configure -background $q
			foreach key [keylget listwindows]\
			{	.win$key.icons.can configure -background $q
			}
			set canbgcol $q
	}
	grid configure .configure.but.cancel -row 1 -column 2
	button .configure.but.save -text "Save" -command \
	{	
		set fil [open ~/.sfm/.sfmrc w]
		set q [lindex [.center.icons.buttons.home \
			configure -activebackground] 4]
		puts $fil "tk_setPalette [lindex [. configure -background] 4]"
		puts $fil "set canbgcol $q"
		close $fil
		set oldcol [lindex [. configure -background] 4]
	}
	grid configure .configure.but.save -row 1 -column 3
	bind .configure <Return> \
	{	catch {destroy .configure
			destroy .configicon}
	}
}
