proc _optList {w lg rel init listchoix}\
{
	menubutton $w -text "$init" -relief $rel -width $lg \
		-menu $w.m
		menu $w.m -tearoff 0
		foreach ch $listchoix\
		{
			$w.m add command -label "$ch"\
				-command "$w configure -text [list $ch]"
		}
	return $w
}

proc _findInfo {f}\
{
	set base [file dirname $f]
	set fil [file tail $f]
	if {! [file isdirectory $f]}\
	{
		set fil [file tail $base]
		set base [file dirname $base]
	}
	_newWindow [_initWindow $base $fil]
	
}

proc _Dfind {}\
{	
	global canbgcol re findpid tailpid finfind
	if {[winfo exists .find]}\
	{	catch {destroy .find
			destroy .findicon}
	}
	toplevel .find -cursor top_left_arrow
	wm geometry .find +100+100
	wm protocol .find WM_DELETE_WINDOW "catch {destroy .find
						destroy .findicon}"
	wm title .find "Find"
		toplevel .findicon
		label .findicon.img -image about
		pack .findicon.img
		wm iconwindow .find .findicon
	frame .find.f1
	pack .find.f1 -fill x -side top
	label .find.f1.wait -text ""
	grid configure .find.f1.wait -row 0 -column 1 -columnspan 2

	label .find.f1.wt -text "Find : "
	grid configure .find.f1.wt -row 1 -column 1 -sticky e
	entry .find.f1.what -width 25 -background $canbgcol
	grid configure .find.f1.what -row 1 -column 2

	label .find.f1.wr -text "In : "
	grid configure .find.f1.wr -row 2 -column 1 -sticky e
	entry .find.f1.where -width 25 -background $canbgcol
	grid configure .find.f1.where -row 2 -column 2

	label .find.f1.tp -text "Type : "
	grid configure .find.f1.tp -row 3 -column 1 -sticky e
	_optList .find.f1.type 15 groove "All files" {"All files" \
		"Regular files" "Directories" "Links" "Block devices" \
		"Character devices" "Pipes" "Sockets"}
	grid configure .find.f1.type -row 3 -column 2

	label .find.f1.sz -text "Size : "
	grid configure .find.f1.sz -row 1 -column 3 -sticky e
	_optList .find.f1.msize 1 flat = {= < >}
	grid configure .find.f1.msize -row 1 -column 4
	entry .find.f1.size -width 5 -background $canbgcol
	grid configure .find.f1.size -row 1 -column 5
	_optList .find.f1.usize 10 flat Blocks {Blocks Bytes Kilobytes Words}
	grid configure .find.f1.usize -row 1 -column 6 -sticky w

	label .find.f1.at -text "Access time : "
	grid configure .find.f1.at -row 2 -column 3 -sticky e
	_optList .find.f1.matime 1 flat = {= < >}
	grid configure .find.f1.matime -row 2 -column 4
	entry .find.f1.atime -width 5 -background $canbgcol
	grid configure .find.f1.atime -row 2 -column 5
	_optList .find.f1.uatime 10 flat Days {Days Minutes}
	grid configure .find.f1.uatime -row 2 -column 6 -sticky w

	label .find.f1.mt -text "Modified time : "
	grid configure .find.f1.mt -row 3 -column 3 -sticky e
	_optList .find.f1.mmtime 1 flat = {= < >}
	grid configure .find.f1.mmtime -row 3 -column 4
	entry .find.f1.mtime -width 5 -background $canbgcol
	grid configure .find.f1.mtime -row 3 -column 5
	_optList .find.f1.umtime 10 flat Days {Days Minutes}
	grid configure .find.f1.umtime -row 3 -column 6 -sticky w

	label .find.f1.ct -text "Created time : "
	grid configure .find.f1.ct -row 4 -column 3 -sticky e
	_optList .find.f1.mctime 1 flat = {= < >}
	grid configure .find.f1.mctime -row 4 -column 4
	entry .find.f1.ctime -width 5 -background $canbgcol
	grid configure .find.f1.ctime -row 4 -column 5
	_optList .find.f1.uctime 10 flat Days {Days Minutes}
	grid configure .find.f1.uctime -row 4 -column 6 -sticky w

	frame .find.f2
	pack .find.f2 -side bottom
	frame .find.mid
	pack .find.mid -fill both -expand yes
	scrollbar .find.mid.vs -takefocus no -command ".find.mid.result yview"
	pack .find.mid.vs -side right -fill y
	listbox .find.mid.result -borderwidth 2 -background $canbgcol \
		-relief sunken -width 60 -height 10 -selectmode single\
		-yscrollcommand ".find.mid.vs set"
	pack .find.mid.result -fill both -side left -expand yes

	bind .find.mid.result <Double-1> {_findInfo [.find.mid.result get [.find.mid.result curselection]]}

	button .find.f2.find -width 8 -text "Find Now" -command \
	{
		set finfind 0
		.find.mid.result delete 0 end
		set where [.find.f1.where get]
		set what [.find.f1.what get]
		set type [.find.f1.type cget -text]
		set msize [.find.f1.msize cget -text]
		set size [.find.f1.size get]
		set usize [.find.f1.usize cget -text]
		set matime [.find.f1.matime cget -text]
		set atime [.find.f1.atime get]
		set uatime [.find.f1.uatime cget -text]
		set mmtime [.find.f1.mmtime cget -text]
		set mtime [.find.f1.mtime get]
		set umtime [.find.f1.umtime cget -text]
		set mctime [.find.f1.mctime cget -text]
		set ctime [.find.f1.ctime get]
		set uctime [.find.f1.uctime cget -text]
		find $where $what $type $msize $size $usize \
			$matime $atime $uatime \
			$mmtime $mtime $umtime \
			$mctime $ctime $uctime
	}
	pack .find.f2.find -side left
	button .find.f2.stop -width 8 -text "Stop" -state disabled \
		-command {
			set finfind 1
			catch {close $re
				kill -9 $findpid
				kill -9 $tailpid}
		}
	pack .find.f2.stop -side left
	button .find.f2.close -width 8 -text "Close" -command {
		catch {close $re
			kill 9 $findpid
			kill 9 $tailpid}
		catch {destroy .find
			destroy .findicon}
	}
	pack .find.f2.close -side right
	focus .find.f1.what
	bind .find <Return> ".find.f2.find flash
			.find.f2.find invoke"
}


proc find {where what type msize size usize matime atime uatime mmtime mtime umtime mctime ctime uctime}\
{
	global home LIBPATH findpid tailpid re finfind
	.find.f2.stop configure -state normal
	.find configure -cursor watch
	.find.f1.wait configure -text "Searching..."
	if {$where == ""}\
	{	set wh "$home"
		.find.f1.where insert 0 $home
	}\
	else\
	{	set wh "$where"
	}
	switch $type \
	{	"All files" 		{	set tp ""}
		"Regular files"		{	set tp "-type f"}
		"Directories"		{	set tp "-type d"}
		"Block devices"		{	set tp "-type b"}
		"Character devices"	{	set tp "-type c"}
		"Links"			{	set tp "-type l"}
		"Pipes"			{	set tp "-type p"}
		"Sockets"		{	set tp "-type s"}
	}
	if {$what == "" || $what == ".*"}\
	{	set wt "-regex $wh/.*$"
		.find.f1.what delete 0 end
		.find.f1.what insert 0 ".*$"
	}\
	else\
	{	set wt "-regex $wh/.*$what.*"
	}
	regsub // $wt / wt
	switch $msize \
	{	"="	{	set msz ""}
		"<"	{	set msz "-"}
		">"	{	set msz "+"}
	}
	switch $usize \
	{	"Blocks"	{	set usz "b"}
		"Bytes"		{	set usz "c"}
		"Kilobytes"	{	set usz "k"}
		"Words"		{	set usz "w"}
	}
	if {$size == ""}\
	{	set sz ""
	}\
	else\
	{	set sz "-size $msz$size$usz"
	}
	switch $matime \
	{	"="	{	set mat ""}
		"<"	{	set mat "-"}
		">"	{	set mat "+"}
	}
	switch $uatime \
	{	"Days"		{	set uat "-atime"}
		"Minutes"	{	set uat "-amin"}
	}
	if {$atime == ""}\
	{	set at ""
	}\
	else\
	{	set at "$uat $mat$atime"
	}
	switch $mmtime \
	{	"="	{	set mmt ""}
		"<"	{	set mmt "-"}
		">"	{	set mmt "+"}
	}
	switch $umtime \
	{	"Days"		{	set umt "-mtime"}
		"Minutes"	{	set umt "-mmin"}
	}
	if {$mtime == ""}\
	{	set mt ""
	}\
	else\
	{	set mt "$umt $mmt$mtime"
	}
	switch $mctime \
	{	"="	{	set mct ""}
		"<"	{	set mct "-"}
		">"	{	set mct "+"}
	}
	switch $uctime \
	{	"Days"		{	set uct "-ctime"}
		"Minutes"	{	set uct "-cmin"}
	}
	if {$ctime == ""}\
	{	set ct ""
	}\
	else\
	{	set ct "$uct $mct$ctime"
	}
	catch {close $re}
	catch {kill -9 $findpid}
	catch {kill -9 $tailpid}
	set findpid [exec $LIBPATH/scfind $wh $tp $sz $at $mt $ct $wt &]
	set tailpid [exec $LIBPATH/sctail &]
	set re [open $home/.sfm/tail.tmp w+]
	set ps [exec $LIBPATH/scps $findpid]
	set results ""
	while {$ps && ! $finfind}\
	{	
		catch {set results [read $re]}
		if {$results != ""}\
		{	
			foreach res [split $results \n]\
			{
				catch {.find.mid.result insert end $res}
				update
			}
		}
		set ps [exec $LIBPATH/scps $findpid]
		after 1000
	}
	set results "AaaA"
	catch {set results [read $re]}
	if {$results != "AaaA"}\
	{	
		foreach res [split $results \n]\
		{
			catch {.find.mid.result insert end $res}
			update
		}
	}
	catch {kill 9 $tailpid}
	catch {close $re}
	catch {kill 9 $findpid}
	set findfind 1
	catch {.find.f1.wait configure -text ""}
	.find configure -cursor top_left_arrow
	catch {.find.f2.stop configure -state disabled}
}


