proc Dhelp {}\
{
	global HLPPATH
	if {[winfo exists .help]}\
	{	destroy .help
		destroy .helpicon
	}
	toplevel .help -cursor top_left_arrow
	set font "-*-Helvetica-Bold-R-Normal--*-180-*-*-*-*-*-*"
	wm protocol .help WM_DELETE_WINDOW "catch {destroy .help
						destroy .helpicon}"
	wm title .help "Help"
	wm geometry .help 40x15+20+20
		toplevel .helpicon
		label .helpicon.img -image about
		pack .helpicon.img
		wm iconwindow .help .helpicon
	frame .help.bot
	pack .help.bot -side bottom 
	frame .help.top
	pack .help.top -side top -expand yes -fill both
	text .help.top.c -yscrollcommand ".help.top.vs set" -setgrid true \
		-background #FFFFFF -width 20 -height 14 -font $font -wrap word 
	scrollbar .help.top.vs -command ".help.top.c yview"
	pack .help.top.vs -side right -fill y
	pack .help.top.c -expand yes -fill both

	helpMenu

	button .help.bot.menu -text Menu -command "helpMenu"
	pack .help.bot.menu -side left
	button .help.bot.ok -text Close -command "catch {destroy .help
							destroy .helpicon}"
	pack .help.bot.ok -side left
	bind .help <Return> "catch {destroy .help
				destroy .helpicon}"
	focus .help
}

proc helpMenu {}\
{
	wm title .help "Help"
	.help.top.c configure -state normal
	.help.top.c delete 1.0 end
	if {[winfo depth .help.top] > 1}\
	{
    		set bold "-background #FFDD00 -relief raised -borderwidth 1"
    		set normal "-background {} -relief flat"
	}\
	else\
	{
    		set bold "-foreground white -background black"
    		set normal "-foreground {} -background {}"
	}
	.help.top.c tag configure titre -lmargin1 10
	.help.top.c insert end \n
	.help.top.c insert end "Simple File Manager Version 1.5\nby Marie Caroline Pavoine\nNovember 1st 2001" titre
	.help.top.c insert end \n\n
	.help.top.c insert end {   1. Introduction    } d1
	.help.top.c insert end \n\n
	.help.top.c insert end {   2. General menu    } d2
	.help.top.c insert end \n\n
	.help.top.c insert end {   3. File menu       } d3
	.help.top.c insert end \n\n
	.help.top.c insert end {   4. Directory menu  } d4
	.help.top.c insert end \n\n
	.help.top.c insert end {   5. Tools menu      } d5
	.help.top.c insert end \n\n
	.help.top.c insert end {   6. Window menu     } d6
	.help.top.c insert end \n\n
	.help.top.c insert end {   7. Help menu       } d7
	foreach tag {d1 d2 d3 d4 d5 d6 d7}\
	{
    		.help.top.c tag bind $tag <Any-Enter> \
			".help.top.c tag configure $tag $bold"
    		.help.top.c tag bind $tag <Any-Leave> \
			".help.top.c tag configure $tag $normal"
	}
	.help.top.c tag bind d1 <1> {helpIntro}
	.help.top.c tag bind d2 <1> {helpGeneral}
	.help.top.c tag bind d3 <1> {helpFile}
	.help.top.c tag bind d4 <1> {helpDirectory}
	.help.top.c tag bind d5 <1> {helpTools}
	.help.top.c tag bind d6 <1> {helpWindow}
	.help.top.c tag bind d7 <1> {helpHelp}
	.help.top.c configure -state disabled
}


proc helpIntro {}\
{
	set font1 "-*-Helvetica-Bold-R-Normal--*-180-*-*-*-*-*-*"
	set font2 "-*-Helvetica-Bold-R-Normal--*-140-*-*-*-*-*-*"
	set font3 "-*-Helvetica-Medium-R-Normal--*-180-*-*-*-*-*-*"
	wm title .help "Help : General menu"
	.help.top.c configure -state normal
	.help.top.c delete 1.0 end

	.help.top.c tag configure titre -lmargin1 10 -font ${font1}
	.help.top.c tag configure soustitre -lmargin1 10 -font ${font3}
	.help.top.c tag configure texte -lmargin1 10 -lmargin2 92 \
		-font ${font2}
	.help.top.c tag configure texte1 -font ${font2} -lmargin1 10 \
		-lmargin2 10 

	.help.top.c insert end \n
	.help.top.c insert end {SFM 1.5 is composed of a main window and many other secondary windows that can be opened for convenience.} texte1
	.help.top.c insert end \n\n
	.help.top.c insert end {The main window is made in two parts :} soustitre
	.help.top.c insert end \n
	.help.top.c insert end "	- The left tree\n	- The right icon panel" texte
	.help.top.c insert end \n\n
	.help.top.c insert end {In the left tree :} soustitre
	.help.top.c insert end \n
	.help.top.c insert end "	- Left click on an element to open or close the associated tree\n	- Right click on an element to display its content on the right icon panel" texte
	.help.top.c insert end \n\n
	.help.top.c insert end {In the right icon panel :} soustitre
	.help.top.c insert end \n
	.help.top.c insert end "	- Left double-click on an element to open a directory or display the \"Open\" dialog box.\n	- Shift-Left click or Ctrl-Left click to select more than one element.\n	- Right click on an element to display a contextual menu for the element.\n	- Right click on the panel to display a contextual menu for the entire panel." texte
	.help.top.c insert end \n\n
	.help.top.c insert end {Other features} soustitre
	.help.top.c insert end \n
	.help.top.c insert end "	- Use the shortcuts indicated at the right of a menu entry.\n	- Use the Configurations menu entry and save your changes. The next time you open SFM, the color scheme you choose will automaticaly be set.\n	- Use the trash to restore the files you deleted before.\n	- Use small square icons at the top right to access your home, the trash and the floppy.\n	- Find module that search for files with \"-regex\". Use \".*\" as wildcard." texte
	.help.top.c insert end \n\n
	.help.top.c insert end {Report bugs} soustitre
	.help.top.c insert end \n
	.help.top.c insert end {If you find any bug in this version or you have some comment or suggestions to make, contact me at mpavoine@hotmail.com. I'll then try to make the appropriated changes in the further versions.} texte1
	.help.top.c insert end \n
	.help.top.c insert end {} texte
	.help.top.c configure -state disabled
}



proc helpGeneral {}\
{
	set font1 "-*-Helvetica-Bold-R-Normal--*-180-*-*-*-*-*-*"
	set font2 "-*-Helvetica-Bold-R-Normal--*-140-*-*-*-*-*-*"
	wm title .help "Help : General menu"
	.help.top.c configure -state normal
	.help.top.c delete 1.0 end
	.help.top.c insert end \n
	.help.top.c insert end {Empty trash} titre
	.help.top.c tag configure titre -lmargin1 10 -font ${font1} -underline 1
	.help.top.c insert end \n
	.help.top.c insert end {When you send an element to the trash, they go in folder $HOME/.sfm/.trash. Empty the trash remove all the elements in this folder.} texte
	.help.top.c tag configure texte -lmargin1 10 -lmargin2 10 -spacing2 1 -font ${font2}
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Refresh} titre
	.help.top.c insert end \n
	.help.top.c insert end {Redraw all the icons in the right panel.} texte
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Select all} titre
	.help.top.c insert end \n
	.help.top.c insert end {Select all the icons in the panel but the .. icon. This will allow you to move, delete or send trash those icons.} texte
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Configurations} titre
	.help.top.c insert end \n
	.help.top.c insert end {Let you change the color sheme of the entire application, by double-clicking on a list element. Save will write this scheme in $HOME/.sfm/.sfmrc for a next open. OK will simply make changes for now.} texte
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Quit/Close} titre
	.help.top.c insert end \n
	.help.top.c insert end {Quit the application, asking you for a confirmation, if you are in the main window. In a secondary window, the close command will close the current window.} texte
	.help.top.c configure -state disabled
}

proc helpFile {}\
{
	set font1 "-*-Helvetica-Bold-R-Normal--*-180-*-*-*-*-*-*"
	set font2 "-*-Helvetica-Bold-R-Normal--*-140-*-*-*-*-*-*"
	wm title .help "Help : File menu"
	.help.top.c configure -state normal
	.help.top.c delete 1.0 end
	.help.top.c insert end \n
	.help.top.c insert end {Copy} titre
	.help.top.c tag configure titre -lmargin1 10 -font ${font1} -underline 1
	.help.top.c insert end \n
	.help.top.c insert end {Copy the selected file in the clipboard.} texte
	.help.top.c tag configure texte -lmargin1 10 -lmargin2 10 -spacing2 1 -font ${font2}
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Paste} titre
	.help.top.c insert end \n
	.help.top.c insert end {Paste a previously copied file into the directory currently displayed.} texte
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Send to trash} titre
	.help.top.c insert end \n
	.help.top.c insert end {Send all the selected files to the trash, moving them to $HOME/.sfm/.trash, asking for a confirmation before.} texte
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Delete} titre
	.help.top.c insert end \n
	.help.top.c insert end {Remove all the selected files without confirmation. There is no simple way to recover those files.} texte
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Rename} titre
	.help.top.c insert end \n
	.help.top.c insert end {Prompts you for a new name for the selected file} texte
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Link} titre
	.help.top.c insert end \n
	.help.top.c insert end {Prompts you for a link name for the selected file. You can do hard or symbloic link} texte
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Open} titre
	.help.top.c insert end \n
	.help.top.c insert end {If the selected item is a directory, this displays the content af the directory in the current window. If it is a file, it prompts you for an argument (executable file) or an application to open it (regular file).} texte
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Open in a new window} titre
	.help.top.c insert end \n
	.help.top.c insert end {If the selected item is a directory, his content will be displayed in a new window} texte
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Permissions} titre
	.help.top.c insert end \n
	.help.top.c insert end {Show the read/write/execute permissions for the selected file.} texte
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Properties} titre
	.help.top.c insert end \n
	.help.top.c insert end {Show informations (name, size, owner, etc) about the selected file.} texte
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Show hidden files} titre
	.help.top.c insert end \n
	.help.top.c insert end {Show all files, including those beggining with a period.} texte
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Hide hidden files} titre
	.help.top.c insert end \n
	.help.top.c insert end {Show all files but those beggining with a period.} texte
	.help.top.c configure -state disabled
}

proc helpDirectory {}\
{
	set font1 "-*-Helvetica-Bold-R-Normal--*-180-*-*-*-*-*-*"
	set font2 "-*-Helvetica-Bold-R-Normal--*-140-*-*-*-*-*-*"
	wm title .help "Help : General menu"
	.help.top.c configure -state normal
	.help.top.c delete 1.0 end
	.help.top.c insert end \n
	.help.top.c insert end {Home} titre
	.help.top.c tag configure titre -lmargin1 10 -font ${font1} -underline 1
	.help.top.c insert end \n
	.help.top.c insert end {Open your home directory in the current window.} texte
	.help.top.c tag configure texte -lmargin1 10 -lmargin2 10 -spacing2 1 -font ${font2}
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Trash} titre
	.help.top.c insert end \n
	.help.top.c insert end {Open $HOME/.sfm/.trash in a new window.} texte
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {New} titre
	.help.top.c insert end \n
	.help.top.c insert end {Prompts you for the name of a new directory that will be created.} texte
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Change} titre
	.help.top.c insert end \n
	.help.top.c insert end {Prompts you for a directory to display. It can be an absolute path or a path relative to the window's current directory.} texte
	.help.top.c configure -state disabled
}

proc helpTools {}\
{
	set font1 "-*-Helvetica-Bold-R-Normal--*-180-*-*-*-*-*-*"
	set font2 "-*-Helvetica-Bold-R-Normal--*-140-*-*-*-*-*-*"
	wm title .help "Help : General menu"
	.help.top.c configure -state normal
	.help.top.c delete 1.0 end
	.help.top.c insert end \n
	.help.top.c insert end {Find} titre
	.help.top.c tag configure titre -lmargin1 10 -font ${font1} -underline 1
	.help.top.c insert end \n
	.help.top.c insert end {Find files by name, size, date, type. Double-click on a found item and open the directory or the enclosing directory. Stop the search with the stop button. Searches are made using Unix find with "-regex" option. Use ".,*,?,+" as wildcards. See the find man entry for more informations.} texte
	.help.top.c tag configure texte -lmargin1 10 -lmargin2 10 -spacing2 1 -font ${font2}
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Open /floppy} titre
	.help.top.c insert end \n
	.help.top.c insert end {Opens in a new window /floppy, trying to mount the floppy. If the floppy cannot be mounted, it opens /floppy in the base file system.} texte
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Mount} titre
	.help.top.c insert end \n
	.help.top.c insert end {Try to mount /dev/fd0.} texte
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Umount} titre
	.help.top.c insert end \n
	.help.top.c insert end {Try to unmount /dev/fd0.} texte
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Start xflop} titre
	.help.top.c insert end \n
	.help.top.c insert end {If xflop is installed on your system, start xflop, a mount/umount/status floppy manager.} texte
	.help.top.c configure -state disabled
}

proc helpWindow {}\
{
	set font1 "-*-Helvetica-Bold-R-Normal--*-180-*-*-*-*-*-*"
	set font2 "-*-Helvetica-Bold-R-Normal--*-140-*-*-*-*-*-*"
	wm title .help "Help : General menu"
	.help.top.c configure -state normal
	.help.top.c delete 1.0 end
	.help.top.c insert end \n
	.help.top.c insert end {Close all windows} titre
	.help.top.c tag configure titre -lmargin1 10 -font ${font1} -underline 1
	.help.top.c insert end \n
	.help.top.c insert end {Close all opened windows listed in the Window menu. Don't close main window.} texte
	.help.top.c tag configure texte -lmargin1 10 -lmargin2 10 -spacing2 1 -font ${font2}
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Open /floppy} titre
	.help.top.c insert end \n
	.help.top.c insert end {Opens in a new window /floppy, trying to mount the floppy. If the floppy cannot be mounted, it opens /floppy in the base file system.} texte
	.help.top.c configure -state disabled
}

proc helpHelp {}\
{
	set font1 "-*-Helvetica-Bold-R-Normal--*-180-*-*-*-*-*-*"
	set font2 "-*-Helvetica-Bold-R-Normal--*-140-*-*-*-*-*-*"
	wm title .help "Help : General menu"
	.help.top.c configure -state normal
	.help.top.c delete 1.0 end
	.help.top.c insert end \n
	.help.top.c insert end {About SFM} titre
	.help.top.c tag configure titre -lmargin1 10 -font ${font1} -underline 1
	.help.top.c insert end \n
	.help.top.c insert end {Click or press Enter to hide the About window.} texte
	.help.top.c tag configure texte -lmargin1 10 -lmargin2 10 -spacing2 1 -font ${font2}
	.help.top.c insert end \n
	.help.top.c insert end \n
	.help.top.c insert end {Help} titre
	.help.top.c insert end \n
	.help.top.c insert end {Opens this window.} texte
	.help.top.c configure -state disabled
}
