
proc _initWindow {p title}\
{
	global listwindows numwindow
	incr numwindow
	if {! [regexp ^/$ $p]}\
	{
		keylset listwindows $numwindow.old $p/$title
		keylset listwindows $numwindow.title $p/$title
		keylset listwindows $numwindow.cwd $p/$title
	}\
	else\
	{
		keylset listwindows $numwindow.old /$title
		keylset listwindows $numwindow.title /$title
		keylset listwindows $numwindow.cwd /$title
	}
	return $numwindow
}    

proc _newWindow {id} \
{
	global listwindows dir scrw scrh canbgcol
	toplevel .win$id
	wm geometry .win$id [expr $scrw - 200]x[expr $scrh - 200]+[expr 10* ($id % 10)]+[expr 10* ($id % 10)]
	wm title .win$id [keylget listwindows $id.title]
	wm protocol .win$id WM_DELETE_WINDOW "_closeWindow $id"
		toplevel .win$id"icon"
		label .win$id"icon".img -image about
		pack .win$id"icon".img
		wm iconwindow .win$id .win$id"icon"
	frame .win$id.menuBar -height 50
	pack .win$id.menuBar -side top -fill x



	menubutton .win$id.menuBar.general -text General \
		-menu .win$id.menuBar.general.m -underline 0
	menu .win$id.menuBar.general.m -tearoff 0
		.win$id.menuBar.general.m add command -label "Empty trash"  \
			-accelerator "Ctrl-y"\
			-underline 4 -command "emptyTrash .center.icons.can"
		.win$id.menuBar.general.m add separator
		.win$id.menuBar.general.m add command -label "Refresh" \
			-accelerator "Ctrl-f"\
			-underline 2 -command "_changeDirWindow $id"
		.win$id.menuBar.general.m add command -label "Select all"\
			-accelerator "Ctrl-a"\
			-command "_selectAllWindow $id"
		.win$id.menuBar.general.m add separator
		.win$id.menuBar.general.m add command -label "Configurations" \
			-underline 6 -accelerator "Ctrl-u"\
			-command "_Dconfigure2 0 .win$id.icons.can"
		.win$id.menuBar.general.m add separator
		.win$id.menuBar.general.m add command -label "Close"  \
			-accelerator "Ctrl-q"\
			-underline 0 -command "_closeWindow $id"
	pack .win$id.menuBar.general -side left

	menubutton .win$id.menuBar.file -text File \
		-menu .win$id.menuBar.file.m -underline 0
	menu .win$id.menuBar.file.m -tearoff 0
		.win$id.menuBar.file.m add command -label "Copy" -underline 0\
			-accelerator "Ctrl-c"\
			-command "itemCopy $id .win$id.icons.can"
		.win$id.menuBar.file.m add command -label "Paste" -underline 0\
			-accelerator "Ctrl-v"\
			-command "itemPaste $id p .win$id.icons.can"
		.win$id.menuBar.file.m add command -label "Send to trash" \
			-underline 1 -accelerator "Ctrl-e"\
			-command "sendTrash $id .win$id.icons.can"
		.win$id.menuBar.file.m add command -label "Delete" -underline 0\
			-accelerator "Ctrl-x"\
			-command "deleteDirect $id .win$id.icons.can"
		.win$id.menuBar.file.m add command -label "Rename" -underline 0\
			-accelerator "Ctrl-r"\
			-command "DitemRename $id .win$id.icons.can"
		.win$id.menuBar.file.m add command -label "Link" -underline 0\
			-accelerator "Ctrl-l"\
			-command "DitemLink $id .win$id.icons.can"
		.win$id.menuBar.file.m add command -label "Open" -underline 0\
			-accelerator "Ctrl-o"\
			-command "_itemOpenWindow $id"
		.win$id.menuBar.file.m add command \
			-label "Open in a new window" -underline 14\
			-accelerator "Ctrl-w"\
			-command "newOpen $id .win$id.icons.can"
		.win$id.menuBar.file.m add separator
		.win$id.menuBar.file.m add command -label "Permissions" \
			-underline 4 -accelerator "Ctrl-i"\
			-command "DitemPermissions $id .win$id.icons.can"
		.win$id.menuBar.file.m add command -label "Properties" \
			-underline 6 -accelerator "Ctrl-t"\
			-command "DitemProperties $id .win$id.icons.can"
		.win$id.menuBar.file.m add separator
		.win$id.menuBar.file.m add command -label "Show hidden files" \
			-accelerator "Ctrl-s"\
			-underline 0 -command "showHidden"
		.win$id.menuBar.file.m add command -label "Hide hidden files" \
			-accelerator "Ctrl-h"\
			-underline 0 -command "hideHidden"
	pack .win$id.menuBar.file -side left
	
	menubutton .win$id.menuBar.directory -text Directory \
		-menu .win$id.menuBar.directory.m  -underline 0
	menu .win$id.menuBar.directory.m -tearoff 0
		.win$id.menuBar.directory.m add command -label "Home"  \
			-accelerator "Ctrl-m"\
			-underline 2 -command "keylset listwindows $id.cwd ~
					_changeDirWindow $id"
		.win$id.menuBar.directory.m add command -label "Trash" \
			-accelerator "Ctrl-z"\
			-underline 2 -command "keylset listwindows \
						$id.cwd ~/.sfm/.trash
					_changeDirWindow $id"
		.win$id.menuBar.directory.m add separator
		.win$id.menuBar.directory.m add command -label "New" \
			-accelerator "Ctrl-n"\
			-underline 0 -command "DnewDir $id .win$id.icons.can"
		.win$id.menuBar.directory.m add command -label "Change"  \
			-underline 4 -accelerator "Ctrl-g"\
			-command "DchangeDir $id .win$id.icons.can"
	pack .win$id.menuBar.directory -side left

	menubutton .win$id.menuBar.tools -text Tools \
		-menu .win$id.menuBar.tools.m -underline 0
	menu .win$id.menuBar.tools.m -tearoff 0
		.win$id.menuBar.tools.m add command -label "Find" \
			-underline 3 -accelerator "Ctrl-d" \
			-command "_Dfind"
		.win$id.menuBar.tools.m add cascade -label "Floppy" \
			-menu .win$id.menuBar.tools.m.flop -underline 0
		menu .win$id.menuBar.tools.m.flop -tearoff 0
			.win$id.menuBar.tools.m.flop add command \
				-label "Open /floppy" \
				-underline 0 \
				-command {catch {exec mount /dev/fd0}
					_newWindow [_initWindow / floppy]
				}
			.win$id.menuBar.tools.m.flop add command \
				-label "Mount" \
				-underline 0 -command {
					set ct [catch {exec mount /dev/fd0} \
						errmsg]
					if {$ct > 0}\
					{	tk_dialog .baddir {Error}\
							$errmsg {} 0 OK
					}\
					else\
					{
						_newWindow [_initWindow / floppy]
					}
				}
			.win$id.menuBar.tools.m.flop add command \
				-label "Umount"  -underline 0 \
				-command {
					set ct [catch {exec umount /dev/fd0} \
						errmsg]
					if {$ct > 0}\
					{	tk_dialog .baddir {Error}\
							$errmsg {} 0 OK
					}\
					else\
					{
						foreach key [keylget listwindows]\
						{	
							if {[regexp ^/floppy [keylget listwindows $key.cwd]]}\
							{	_closeWindow $key
							}
						}
					}
				}
			.win$id.menuBar.tools.m.flop add separator
			.win$id.menuBar.tools.m.flop add command \
				-label "Start xflop" \
				-accelerator "F2"\
				-underline 0 -command "catch {exec xflop &}"
	pack .win$id.menuBar.tools -side left

	menubutton .win$id.menuBar.window -text Window \
		-menu .win$id.menuBar.window.m -underline 0
	menu .win$id.menuBar.window.m -tearoff 0
		.win$id.menuBar.window.m add command \
			-label "Close all windows" -underline 0\
			-command "_closeAllWindows"
		.win$id.menuBar.window.m add command \
			-label "Open /floppy" \
			-underline 0 \
			-command {catch {exec mount /dev/fd0}
				_newWindow [_initWindow / floppy]
			}
		.win$id.menuBar.window.m add separator
	pack .win$id.menuBar.window -side left

	menubutton .win$id.menuBar.help -text Help \
		-menu .win$id.menuBar.help.m -underline 0
	menu .win$id.menuBar.help.m -tearoff 0
		.win$id.menuBar.help.m add command -label "About SFM" \
			-accelerator "Ctrl-b"\
			-underline 1 -command "Dabout"
		.win$id.menuBar.help.m add separator
		.win$id.menuBar.help.m add command -label "Help" -underline 0\
			-accelerator "F1" -command "Dhelp"
	pack .win$id.menuBar.help -side right

	menu .win$id.droit -tearoff 0
		.win$id.droit add command -label "Paste" \
			-command "itemPaste $id p .win$id.icons.can"
		.win$id.droit add command -label "Select all" \
			-command "_selectAllWindow $id"
		.win$id.droit add separator
		.win$id.droit add command -label "Show hidden files" \
			-command "showHidden"
		.win$id.droit add command -label "Hide hidden files" \
			-command "hideHidden"
		.win$id.droit add separator
		.win$id.droit add command -label "Home" \
			-command "keylset listwindows $id.cwd ~
				_changeDirWindow $id"
		.win$id.droit add command -label "Trash" \
			-command "keylset listwindows \
						$id.cwd ~/.sfm/.trash
					_changeDirWindow $id"
		.win$id.droit add separator
		.win$id.droit add command -label "New directory" \
			-command "DnewDir $id .win$id.icons.can"
		.win$id.droit add command -label "Change directory"  \
			-command "DchangeDir $id .win$id.icons.can"
		.win$id.droit add separator
		.win$id.droit add command -label "Refresh" \
			-command "_changeDirWindow $id"
		.win$id.droit add separator
		.win$id.droit add command -label "Start xflop" \
			-command "catch {exec xflop &}"
		.win$id.droit add separator
		.win$id.droit add command -label "Empty trash"  -underline 0\
			-command "emptyTrash .center.icons.can"

	menu .win$id.droiticons -tearoff 0
		.win$id.droiticons add command -label "Copy" \
			-command "itemCopy $id .win$id.icons.can"
		.win$id.droiticons add command -label "Send to trash" \
			-command "sendTrash $id .win$id.icons.can"
		.win$id.droiticons add command -label "Delete" \
			-command "deleteDirect $id .win$id.icons.can"
		.win$id.droiticons add command -label "Rename" \
			-command "DitemRename $id .win$id.icons.can"
		.win$id.droiticons add command -label "Link" \
			-command "DitemLink $id .win$id.icons.can"
		.win$id.droiticons add command -label "Open" \
			-command "_itemOpenWindow $id"
		.win$id.droiticons add command -label "Open in an new window" \
			-command "newOpen $id .win$id.icons.can"
		.win$id.droiticons add separator
		.win$id.droiticons add command -label "Permissions" \
			-command "DitemPermissions $id .win$id.icons.can"
		.win$id.droiticons add command -label "Properties"  \
			-command "DitemProperties $id .win$id.icons.can"

	frame .win$id.icons 
	pack .win$id.icons -side bottom -fill both -expand yes
	scrollbar .win$id.icons.hs -orient horiz \
		-command ".win$id.icons.can xview"
	pack .win$id.icons.hs -side bottom -fill x
	scrollbar .win$id.icons.vs -command ".win$id.icons.can yview"
	pack .win$id.icons.vs -side right -fill y
	canvas .win$id.icons.can -relief sunken -borderwidth 2 \
		-background $canbgcol \
		-xscrollcommand ".win$id.icons.hs set"\
		-yscrollcommand ".win$id.icons.vs set"
	pack .win$id.icons.can -expand yes -fill both

	.menuBar.window.m add command \
			-label "[keylget listwindows $id.title]" \
			-command "raise .win$id
				focus .win$id"
	foreach key [keylget listwindows]\
	{	 
		.win$key.menuBar.window.m add command \
			-label [keylget listwindows $key.title]\
			-command "raise .win$key
				focus .win$key"
	} 

	bind .win$id.icons.can <Double-1> "_itemOpenWindow $id"
	bind .win$id.icons.can <Shift-B1-ButtonRelease> "_itemDecideShift \
		$id %X %Y"
	bind .win$id.icons.can <Shift-1> "_itemLeftShift $id %X %Y"
	bind .win$id.icons.can <Control-B1-ButtonRelease> "_itemDecideShift \
		$id %X %Y"
	bind .win$id.icons.can <Control-1> "_itemLeftShift $id %X %Y"
	bind .win$id.icons.can <1> "_itemLeftWindow $id %X %Y"
	bind .win$id.icons.can <B1-ButtonRelease> "_itemDecideWindow $id %X %Y"
	bind .win$id.icons.can <3> "_itemPopupWindow $id %X %Y"

	bind .win$id <Control-y> ".win$id.menuBar.general.m invoke 0"
	bind .win$id <Control-f> ".win$id.menuBar.general.m invoke 2"
	bind .win$id <Control-a> ".win$id.menuBar.general.m invoke 3"
	bind .win$id <Control-u> ".win$id.menuBar.general.m invoke 5"
	bind .win$id <Control-q> ".win$id.menuBar.general.m invoke 7"
	bind .win$id <Control-c> ".win$id.menuBar.file.m invoke 0"
	bind .win$id <Control-v> ".win$id.menuBar.file.m invoke 1"
	bind .win$id <Control-e> ".win$id.menuBar.file.m invoke 2"
	bind .win$id <Control-x> ".win$id.menuBar.file.m invoke 3"
	bind .win$id <Control-r> ".win$id.menuBar.file.m invoke 4"
	bind .win$id <Control-l> ".win$id.menuBar.file.m invoke 5"
	bind .win$id <Control-o> ".win$id.menuBar.file.m invoke 6"
	bind .win$id <Control-w> ".win$id.menuBar.file.m invoke 7"
	bind .win$id <Control-i> ".win$id.menuBar.file.m invoke 9"
	bind .win$id <Control-t> ".win$id.menuBar.file.m invoke 10"
	bind .win$id <Control-s> ".win$id.menuBar.file.m invoke 12"
	bind .win$id <Control-h> ".win$id.menuBar.file.m invoke 13"
	bind .win$id <Control-m> ".win$id.menuBar.directory.m invoke 0"
	bind .win$id <Control-z> ".win$id.menuBar.directory.m invoke 1"
	bind .win$id <Control-n> ".win$id.menuBar.directory.m invoke 3"
	bind .win$id <Control-g> ".win$id.menuBar.directory.m invoke 4"
	bind .win$id <Control-d> ".win$id.menuBar.tools.m invoke 0"
	bind .win$id <F2> ".win$id.menuBar.tools.m.flop invoke 4"
	bind .win$id <Control-b> ".win$id.menuBar.help.m invoke 0"
	bind .win$id <F1> ".win$id.menuBar.help.m invoke 3"




	_changeDirWindow $id
}

proc _itemPopupWindow {id x y}\
{
	if {! [regexp selected [.win$id.icons.can gettags current]]}\
	{
		_enableMenu $id
		.win$id.icons.can dtag selected
		_itemLeaveWindow $id
		.win$id.icons.can addtag selected withtag current	
	}	
	set a [.win$id.icons.can gettags current]
	if {[regexp ^icone $a]}\
	{	
		_itemEnterWindow $id
		tk_popup .win$id.droiticons $x $y
	}\
	else\
	{	tk_popup .win$id.droit $x $y
	}
}


proc _DitemMoveWindow {i wold i2 wnew}\
{
	global listwindows id id2 c sel new n
	global listicons$i listicons$i2 s dir tmp
	set id $i
	set id2 $i2
	set sel {}
	foreach ic [$wold find all]\
	{
		if {[regexp selected [$wold gettags $ic]]}\
		{
			lappend sel [keylget listicons$id \
				[lindex [$wold gettags $ic] 0]]
		}
	}
	if {$id2==0}\
	{
		set n [pwd]
	}\
	else\
	{
		set n [keylget listwindows $id2.cwd]
	}
	set ct [catch {set new $n/[keylget listicons$id2 \
		[lindex [$wnew gettags current] 0]]}]
	if {$ct > 0}\
	{
		set new $n
	}
	if {[file isdirectory $new]}\
	{
		set c $wnew
	}
	regsub // $new / new
	if {[winfo exists .itemMove]}\
	{	destroy .itemMove
		destroy .imoveicon
	}
	toplevel .itemMove -cursor top_left_arrow
	wm protocol .itemMove WM_DELETE_WINDOW "catch {destroy .itemMove
							destroy .imoveicon}"
	wm geometry .itemMove +100+100
	wm minsize .itemMove 250 90
	wm title .itemMove "Confirmation"
		toplevel .imoveicon
		label .imoveicon.img -image about
		pack .imoveicon.img
		wm iconwindow .itemMove .imoveicon
	frame .itemMove.ent
	pack .itemMove.ent
	label .itemMove.ent.txdir -justify left -wraplength 250\
		-text "\nMove \"$sel\" to \"$new\"?" 
	pack .itemMove.ent.txdir -side left
	frame .itemMove.but
	pack .itemMove.but -side bottom
	button .itemMove.but.ok -width 10 -text "OK" -command \
	{	
		foreach ic $sel\
		{
			if {$id == 0}\
			{	set old [pwd]/$ic
			}\
			else\
			{
				set old [keylget listwindows $id.cwd]/$ic
			}
			if {$new == $old}\
			{
				break
			}
			catch {destroy .itemMove
				destroy .imoveicon}
			file stat $old a
			file stat $new b
			if {[regexp [array get a dev] [array get b dev]]}\
			{	set ct [catch {frename $old $new/[file tail $old]}\
					errmsg]
				if {$ct > 0}\
				{	tk_dialog .baddir {Error}\
				 		$errmsg {} 0 OK
					return
				}
			}\
			else\
			{
				_itemCopyWindow $old
				_itemPasteWindow $new .center.icons.can
			}
			foreach key [keylget listwindows]\
			{
				if {[regexp $old [keylget listwindows \
					$key.cwd]]}\
				{	_closeWindow $key
				}
			}
		}
		set dir [pwd]
		changeDir .center.icons.can
		foreach key [keylget listwindows] \
		{
			_changeDirWindow $key
		}
	}
	pack .itemMove.but.ok -side left
	button .itemMove.but.cancel -width 10 -text "Cancel" -command \
	{
		catch {destroy .itemMove
			destroy .imoveicon}
	}
	pack .itemMove.but.cancel -side right
	bind .itemMove <Return> \
	{	
		foreach ic $sel\
		{
			if {$id == 0}\
			{	set old [pwd]/$ic
			}\
			else\
			{
				set old [keylget listwindows $id.cwd]/$ic
			}
			if {$new == $old}\
			{
				break
			}
			catch {destroy .itemMove
				destroy .imoveicon}
			file stat $old a
			file stat $new b
			if {[regexp [array get a dev] [array get b dev]]}\
			{	set ct [catch {frename $old $new/[file tail $old]}\
					errmsg]
				if {$ct > 0}\
				{	tk_dialog .baddir {Error}\
				 		$errmsg {} 0 OK
					return
				}
			}\
			else\
			{
				_itemCopyWindow $old
				_itemPasteWindow $new .center.icons.can
			}
			foreach key [keylget listwindows]\
			{
				if {[regexp $old [keylget listwindows \
					$key.cwd]]}\
				{	_closeWindow $key
				}
			}
		}
		set dir [pwd]
		changeDir .center.icons.can
		foreach key [keylget listwindows] \
		{
			_changeDirWindow $key
		}
	}
	focus .itemMove
}

proc _itemCopyWindow {old}\
{
	clipboard clear
	clipboard append -type FILE_NAME $old
}

proc _itemPasteWindow {new w}\
{
	pushd [pwd]
	set ct [catch {cd $new} errmsg]
	if {$ct > 0}\
	{
		tk_dialog .baddir {Error}\
			$errmsg {} 0 OK
		popd
		return	
	}\
	else\
	{
		set ct [catch {set sel "[selection get -type FILE_NAME \
			-selection CLIPBOARD]"}]
		if {$ct > 0}\
		{
			popd 
			return
		}
		set i ""
		set j 0
		
		if {[file isdirectory "$sel"]}\
		{	pasteRecursive -1 "$new" $w "$sel"
			clipboard clear
			popd
			return
		}
		set ct [catch {set a [read_file "$sel"]
			write_file "$new/[file tail $sel]$i" $a} errmsg]
		if {$ct > 0}\
		{	tk_dialog .baddir {Error}\
				"Cannot copy $sel into $new" {} 0 OK
			clipboard clear
			popd
			return
		}
		clipboard clear
		popd
	}
}

proc _DtreeMoveWindow {id}\
{
	if {[winfo exists .treeMove]}\
	{	destroy .treeMove
		destroy .tmoveicon
	}
	global listicons0 s dir tmp listicons$id i listwindows sel
	set i $id
	set sel {}
	foreach ic [.win$id.icons.can find all]\
	{
		if {[regexp selected [.win$id.icons.can gettags $ic]]}\
		{
			lappend sel [keylget listicons$id \
				[lindex [.win$id.icons.can gettags $ic] 0]]
		}
	}
	toplevel .treeMove -cursor top_left_arrow
	wm protocol .treeMove WM_DELETE_WINDOW "catch {destroy .treeMove
							destroy .tmoveicon}"
	wm geometry .treeMove +100+100
	wm minsize .treeMove 250 90
	wm title .treeMove "Confirmation"
		toplevel .tmoveicon
		label .tmoveicon.img -image about
		pack .tmoveicon.img
		wm iconwindow .treeMove .tmoveicon
	frame .treeMove.ent
	pack .treeMove.ent
	label .treeMove.ent.txdir -justify left -wraplength 250\
		-text "\nMove \"$sel \"\nto\
		 \"$tmp\"?" 
	pack .treeMove.ent.txdir -side left
	frame .treeMove.but
	pack .treeMove.but -side bottom
	button .treeMove.but.ok -width 10 -text "OK" -command \
	{	
		catch {destroy .treeMove
			destroy .tmoveicon}
		foreach ic $sel\
		{
			file stat [keylget listwindows $i.cwd]/$ic a
			file stat $tmp b
			set j [keylget listwindows $i.cwd]
			set k $ic
			if {[regexp [array get a dev] [array get b dev]]}\
			{
				set ct [catch {frename $j/$k $tmp/$k} errmsg]
				if {$ct > 0}\
				{	tk_dialog .baddir {Error}\
						$errmsg {} 0 OK
					return
				}
			}\
			else\
			{
				_itemCopyWindow $j/$k
				_itemPasteWindow $tmp .center.tree.can
			}
			foreach key [keylget listwindows]\
			{
				if {[regexp [pwd]/$ic [keylget listwindows \
					$key.cwd]]}\
				{	_closeWindow $key
				}
			}
		}
		set dir [pwd]
		changeDir .center.icons.can
		foreach key [keylget listwindows]\
		{
			_changeDirWindow $key
		}
	}
	pack .treeMove.but.ok -side left
	button .treeMove.but.cancel -width 10 -text "Cancel" -command \
	{
		catch {destroy .treeMove
			destroy .tmoveicon}
	}
	pack .treeMove.but.cancel -side right
	bind .treeMove <Return> \
	{	
		catch {destroy .treeMove
			destroy .tmoveicon}
		foreach ic $sel\
		{
			file stat [keylget listwindows $i.cwd]/$ic a
			file stat $tmp b
			set j [keylget listwindows $i.cwd]
			set k $ic
			if {[regexp [array get a dev] [array get b dev]]}\
			{
				set ct [catch {frename $j/$k $tmp/$k} errmsg]
				if {$ct > 0}\
				{	tk_dialog .baddir {Error}\
						$errmsg {} 0 OK
					return
				}
			}\
			else\
			{
				_itemCopyWindow $j/$k
				_itemPasteWindow $tmp .center.tree.can
			}
			foreach key [keylget listwindows]\
			{
				if {[regexp [pwd]/$ic [keylget listwindows \
					$key.cwd]]}\
				{	_closeWindow $key
				}
			}
		}
		set dir [pwd]
		changeDir .center.icons.can
		foreach key [keylget listwindows]\
		{
			_changeDirWindow $key
		}
	}
	focus .treeMove
}

proc _itemLeftWindow {id x y}\
{
	set a [lindex [.win$id.icons.can gettags current] 0]
	if {[regexp selected [.win$id.icons.can gettags current]]}\
	{
		_itemLeftShift $id $x $y
		return
	}
	_enableMenu $id
	if {[regexp ^icone $a] || [regexp ^/ $a]}\
	{	
		.win$id.icons.can dtag all selected
		.win$id.icons.can addtag selected withtag $a
		_itemLeaveWindow $id
		_itemStartDragWindow $id $x $y
	}\
	else\
	{
		.win$id.icons.can dtag all selected
		_itemLeaveWindow $id
	}
}	

proc _itemLeftShift {id x y}\
{
	_disableMenu $id
	set a [lindex [.win$id.icons.can gettags current] 0]
	if {[regexp ^icone $a] || [regexp ^/ $a]}\
	{	
		.win$id.icons.can addtag selected withtag $a
		_itemStartDragWindow $id $x $y
	}\
	else\
	{
		.win$id.icons.can dtag all selected
		_itemLeaveWindow $id
	}
}	

proc _selectAllWindow {id}\
{
	global listicons$id
	_disableMenu $id
	foreach ic [.win$id.icons.can find all]\
	{
		if {[regexp ^icone [.win$id.icons.can gettags $ic]]}\
		{
			if {[keylget listicons$id [lindex \
				[.win$id.icons.can gettags $ic] 0]] != ".."}\
			{
				.win$id.icons.can addtag selected withtag $ic
				.win$id.icons.can itemconfig $ic \
					-foreground SteelBlue2
				_itemStartDragWindow $id 0 0
			}
		}
	}
}

proc _itemDecideWindow {id x y}\
{
	set g [lindex [.win$id.icons.can gettags selected] 0]
	set w [winfo containing $x $y]
	if {$g == "" || ! [regexp ^icone $g]}\
	{
		return
	}
	if {! [regexp can$ $w]}\
	{	
		.win$id.icons.can dtag all selected
		_itemLeaveWindow $id
		return
	}
	focus $w
	update
	set sel {}
	foreach ic [.win$id.icons.can find all]\
	{
		if {[regexp selected [.win$id.icons.can gettags $ic]]}\
		{
			lappend sel  \
				[lindex [.win$id.icons.can gettags $ic] 0]
		}
	}
	_itemStopDragWindow $id $w "" $sel $x $y
	.win$id.icons.can configure -cursor top_left_arrow
}

proc _itemDecideShift {id x y}\
{
	global listicons$id
	set g [lindex [.win$id.icons.can gettags selected] 0]
	set w [winfo containing $x $y]
	if {$g == "" || ! [regexp ^icone $g]}\
	{
		return
	}
	if {! [regexp can$ $w]}\
	{	
		.win$id.icons.can dtag all selected
		_itemLeaveWindow $id
		return
	}
	focus $w
	update
	set sel {}
	foreach ic [.win$id.icons.can find all]\
	{
		if {[regexp selected [.win$id.icons.can gettags $ic]]}\
		{
			lappend sel  \
				[lindex [.win$id.icons.can gettags $ic] 0]
		}
	}
	_itemStopDragWindow $id $w "" $sel $x $y
}

proc _disableMenu {id}\
{
	.win$id.droiticons entryconfigure 0 -state disabled
	.win$id.droiticons entryconfigure 3 -state disabled
	.win$id.droiticons entryconfigure 4 -state disabled
	.win$id.droiticons entryconfigure 5 -state disabled
	.win$id.droiticons entryconfigure 6 -state disabled
	.win$id.droiticons entryconfigure 8 -state disabled
	.win$id.droiticons entryconfigure 9 -state disabled
	.win$id.menuBar.file.m entryconfigure 0 -state disabled
	.win$id.menuBar.file.m entryconfigure 1 -state disabled
	.win$id.menuBar.file.m entryconfigure 4 -state disabled
	.win$id.menuBar.file.m entryconfigure 5 -state disabled
	.win$id.menuBar.file.m entryconfigure 6 -state disabled
	.win$id.menuBar.file.m entryconfigure 7 -state disabled
	.win$id.menuBar.file.m entryconfigure 9 -state disabled
	.win$id.menuBar.file.m entryconfigure 10 -state disabled
}

proc _enableMenu {id}\
{
	.win$id.droiticons entryconfigure 0 -state normal
	.win$id.droiticons entryconfigure 3 -state normal
	.win$id.droiticons entryconfigure 4 -state normal
	.win$id.droiticons entryconfigure 5 -state normal
	.win$id.droiticons entryconfigure 6 -state normal
	.win$id.droiticons entryconfigure 8 -state normal
	.win$id.droiticons entryconfigure 9 -state normal
	.win$id.menuBar.file.m entryconfigure 0 -state normal
	.win$id.menuBar.file.m entryconfigure 1 -state normal
	.win$id.menuBar.file.m entryconfigure 4 -state normal
	.win$id.menuBar.file.m entryconfigure 5 -state normal
	.win$id.menuBar.file.m entryconfigure 6 -state normal
	.win$id.menuBar.file.m entryconfigure 7 -state normal
	.win$id.menuBar.file.m entryconfigure 9 -state normal
	.win$id.menuBar.file.m entryconfigure 10 -state normal
}

proc _itemEnterWindow {id} \
{
	set type [.win$id.icons.can type current]
    	if {$type == "bitmap"} \
	{
		.win$id.icons.can itemconfig current -foreground SteelBlue2
		return
    	}
}

proc _itemLeaveWindow {id} \
{
	global listcolor
	.win$id.icons.can itemconfig icones -foreground [lindex $listcolor 2]
}

proc _itemStartDragWindow {id x y} \
{
    	global s lastX lastY
    	set s [.win$id.icons.can gettags current] 
	if {$s == ""}\
	{
		return
	}
	if {! [regexp ^icone $s]}\
	{
		return
	}
	.win$id.icons.can configure -cursor dotbox
	_itemEnterWindow $id
    	set lastX [.win$id.icons.can canvasx $x]
    	set lastY [.win$id.icons.can canvasy $y]
}


proc _itemStopDragWindow {id w from g x y}\
{
    	global dir lastX lastY listicons0 listicons$id 
	global listmini listwindows new old tmp
	update
    	set x [$w canvasx $x]
    	set y [$w canvasy $y]
	set n [$w gettags current]
	if {[regexp center.icons.can $w]}\
	{
		set ic [lindex $g 0]
		catch {set p [keylget listicons$id $ic]}
		catch {set n [keylget listicons0 [lindex $n 0]]}
		set old [keylget listwindows $id.cwd]/$p
		set new [pwd]/$n
		if {$new==$old}\
		{
			return
		}
		if {[file isdirectory $new]}\
		{
			_DitemMoveWindow $id .win$id.icons.can 0 $w
		}
	}\
	elseif {[regexp .center.tree.can $w]}\
	{
		if {$n == "" || ! [regexp ^/ $n]}\
		{	
			.win$id.icons.can configure -cursor top_left_arrow
			return
		}
		set tmp [lindex $n 0]
		_DtreeMoveWindow $id
	}\
	elseif {! [regexp ^$w .win$id.icons.can]}\
	{
		set ic [lindex $g 0]
		global listicons[crange $w 4 end-10]
		catch {set p [keylget listicons$id $ic]}
		catch {set n [keylget listicons[crange $w 4 end-10] \
			[lindex $n 0]]}
		set old [keylget listwindows $id.cwd]/$p
		set new [keylget listwindows \
			[crange $w 4 end-10].cwd]/$n
		if {$new==$old}\
		{
			return
		}
		_DitemMoveWindow $id .win$id.icons.can \
			[crange $w 4 end-10] $w
	}\
	elseif {[regexp ^$w .win$id.icons.can]}\
	{
		if {! [regexp .center $from]}\
		{
			set u " "
			catch {set r [lindex $n 0]}
			catch {set u [keylget listicons$id $r]}
			set ic [lindex $g 0]
			if {[file isdirectory [keylget listwindows $id.cwd]/$u]}\
			{
				set old [keylget listwindows \
					$id.cwd]/[keylget \
					listicons$id $ic]
				set new [keylget listwindows $id.cwd]/$u
				foreach ic $g\
				{	if {"[keylget listwindows \
						$id.cwd]/[keylget \
						listicons$id $ic]" == $new}\
					{
						return
					}
				}
				_DitemMoveWindow $id \
					.win$id.icons.can $id $w
			}\
			else\
			{
				foreach ic $g\
				{
					.win$id.icons.can move $ic \
						[expr $x-$lastX] \
						[expr $y-$lastY]
    					.win$id.icons.can move \
						[keylget listicons$id $ic] \
						[expr $x-$lastX] \
						[expr $y-$lastY]
				}
			}
		}\
		elseif {[regexp .center.icons.can $from]}\
		{
			.center configure -cursor top_left_arrow
				#set old [pwd]/[keylget listicons0 $ic]
				catch {set n [keylget listicons[crange $w 4 end-10] \
					[lindex $n 0]]}
				set new [keylget listwindows \
					[crange $w 4 end-10].cwd]/$n
				#_DitemMoveWindow $id .win$id.icons.can 0 $w
				_DitemMoveWindow 0 \
					$from $id .win$id.icons.can 
					
		}
	}
	.win$id.icons.can configure -cursor top_left_arrow
}

proc _DitemOpenWindow {id}\
{
	global i
	set i $id
	if {[winfo exists .itemOpen]}\
	{	destroy .itemOpen
		destroy .iopenicon
	}
	global listicons$id s dir listwindows
	pushd [pwd]
	cd $dir
	toplevel .itemOpen -cursor top_left_arrow
	wm protocol .itemOpen WM_DELETE_WINDOW "catch {destroy .itemOpen
							destroy .iopenicon}"
	wm geometry .itemOpen 250x90+100+100
	wm title .itemOpen "Open file"
		toplevel .iopenicon
		label .iopenicon.img -image about
		pack .iopenicon.img
		wm iconwindow .itemOpen .iopenicon
	frame .itemOpen.ent
	pack .itemOpen.ent
	set dir $dir/[keylget listicons$id [lindex $s 0]]
	if {[file executable $dir]}\
	{	label .itemOpen.ent.txdir -text "\nArguments to \
			\"[keylget listicons$id [lindex $s 0]]\" : "
		pack .itemOpen.ent.txdir -side left
	}\
	else\
	{
		label .itemOpen.ent.txdir -text "\nOpen \
			\"[keylget listicons$id [lindex $s 0]]\" with :"
		pack .itemOpen.ent.txdir -side left
	}
	entry .itemOpen.ent.comm -width 25 -background #FFFFFF
	pack .itemOpen.ent.comm -side right -anchor s
	frame .itemOpen.but
	pack .itemOpen.but -side bottom
	button .itemOpen.but.ok -width 10 -text "OK" -command \
	{	
		set comm [.itemOpen.ent.comm get]
		catch {destroy .itemOpen
			destroy .iopenicon}
		if {[file executable $dir]}\
		{	set ct [catch {exec $dir $comm} errmsg]
		}\
		else\
		{
			set ct [catch {exec $comm $dir} errmsg]
		}
		if {$ct > 0}\
		{	tk_dialog .baddir {Error}\
				$errmsg {} 0 OK
			keylset listwindows $i.cwd \
				[keylget listwindows $i.old]
			popd
			return
		}
		keylset listwindows $i.old [keylget listwindows $i.cwd]
		_changeDirWindow $i
	}
	pack .itemOpen.but.ok -side left
	button .itemOpen.but.cancel -width 10 -text "Cancel" -command \
	{
		catch {destroy .itemOpen
			destroy .iopenicon}
	}
	pack .itemOpen.but.cancel -side right
	bind .itemOpen <Return> \
	{	
		set comm [.itemOpen.ent.comm get]
		catch {destroy .itemOpen
			destroy .iopenicon}
		if {[file executable $dir]}\
		{	set ct [catch {exec $dir $comm} errmsg]
		}\
		else\
		{
			set ct [catch {exec $comm $dir} errmsg]
		}
		if {$ct > 0}\
		{	tk_dialog .baddir {Error}\
				$errmsg {} 0 OK
			keylset listwindows $i.cwd \
				[keylget listwindows $i.old]
			popd
			return
		}
		keylset listwindows $i.old [keylget listwindows $i.cwd]
		_changeDirWindow $i
	}
	focus .itemOpen.ent.comm
	popd
}

proc _itemOpenWindow {id}\
{
	global s dir listicons$id listwindows
	pushd [pwd]
	cd [keylget listwindows $id.cwd]
    	set s [.win$id.icons.can gettags selected] 
	if {$s == ""}\
	{
		popd
		return
	}
    	if {[regexp ^icone $s]} \
	{
    		set f [keylget listicons$id [lindex $s 0]] 
		if {[file type $f] == "link"}\
		{	set f [file readlink $f]
		}\
		else\
		{	set m [pwd]/
			if {[regexp // $m]}\
			{	set m /
			}
			set f $m$f
		}
		switch [file type $f] \
		directory \
		{
			keylset listwindows $id.old \
				[keylget listwindows $id.cwd]
			keylset listwindows $id.cwd $f
			_changeDirWindow $id
		}\
		characterSpecial\
		{}\
		blockSpecial\
		{}\
		fifo\
		{}\
		link\
		{
		}\
		socket\
		{set ic "socket.bmp"}\
		file\
		{
			set dir [keylget listwindows $id.cwd]
			_DitemOpenWindow $id 
		}
	}
	popd
}
proc _createIconWindow {id i x y col tx}\
{
	global listcolor listicons$id
	global icchar icblock icfifo iclink icsocket icdir icexec icfile icdef
	set ct [catch {switch [file type $tx]\
	{
		characterSpecial\
		{set ic $icchar}\
		blockSpecial\
		{set ic $icblock}
		fifo\
		{set ic $icfifo}\
		link\
		{set ic $iclink}\
		socket\
		{set ic $icsocket}\
		directory\
		{set ic $icdir}\
		file\
		{
			if {[file executable $tx]}\
			{set ic $icexec}\
			else\
			{set ic $icfile}\
		}
		default\
		{set ic $icdef}
	} } errmsg]
	if {$ct > 0}\
	{	set ic $icdef
	}
	set item [.win$id.icons.can create bitmap $x $y \
		-bitmap @[file join $ic]]
	.win$id.icons.can addtag icone$i withtag $item
	.win$id.icons.can addtag icones withtag $item
	.win$id.icons.can itemconfig $item -foreground [lindex $listcolor 2]
	set item [.win$id.icons.can create text $x [expr $y+20] \
		-width 65 -anchor n  -text "$tx" -justify center]
	.win$id.icons.can addtag "$tx" withtag $item
	.win$id.icons.can addtag texte withtag $item
	regsub -all {\\} $tx {\\\\} tx2
	regsub -all "\}" $tx2 "\\\}" tx2
	regsub -all "\{" $tx2 "\\\{" tx2
	regsub -all {\]} $tx2 {\]} tx2
	regsub -all {\[} $tx2 {\[} tx2
	regsub -all {"} $tx2 {\"} tx2
	if {[clength $tx] > 7}\
	{
		.win$id.icons.can bind "$tx" <Any-Enter> ".win$id.icons.can itemconfigure \"$tx2\" -text \"$tx2\""
		.win$id.icons.can bind "$tx" <Any-Leave> "if {[.win$id.icons.can index $tx end] > 14}\
					{	.win$id.icons.can dchars \"$tx2\" 12 end
						.win$id.icons.can insert \"$tx2\" end >>
					}"
		.win$id.icons.can bind icone$i <Any-Enter> ".win$id.icons.can itemconfigure \"$tx2\" -text \"$tx2\""
		.win$id.icons.can bind icone$i <Any-Leave> "if {[.win$id.icons.can index $tx end] > 14}\
					{	.win$id.icons.can dchars \"$tx2\" 12 end
						.win$id.icons.can insert \"$tx2\" end >>
					}"
	}\
	else\
	{
		.win$id.icons.can bind "$tx" <Any-Enter> ""
		.win$id.icons.can bind "$tx" <Any-Leave> ""
		.win$id.icons.can bind icone$i <Any-Enter> ""
		.win$id.icons.can bind icone$i <Any-Leave> ""
	}
	keylset listicons$id icone$i $tx
	.win$id.icons.can configure -scrollregion [.win$id.icons.can bbox all]
	.win$id.icons.can xview moveto 0
}

proc _changeDirWindow {id}\
{
	global dir flaghidden listwindows
	set dir [keylget listwindows $id.cwd]
	pushd [pwd]
	set ct [catch {cd $dir} errmsg]
	if {$ct > 0} \
	{
		tk_dialog .baddir {Error} \
			$errmsg {} 0 OK
		keylset listwindows $id.cwd [keylget listwindows $id.old]
		popd
		return 	
	}\
	else\
	{
		keylset listwindows $id.cwd [pwd]
		catch {destroy .chdir
			destroy .chdiricon}
		if {$flaghidden}\
		{
			set n [lsort [readdir [keylget listwindows $id.cwd]]]
		}\
		else\
		{
			set n [exec ls]
			set n [split $n \n]
		}
		set n [linsert $n 0 ..]
		.win$id.icons.can delete all
		for {set i 0} {$i<[llength $n]} {incr i}\
		{	
			_createIconWindow $id $i [expr 35+70*($i%10)] \
				[expr 35+70*(floor($i/10))]\
			 	blue [lindex $n $i]
		}
		foreach tg [.win$id.icons.can find withtag texte]\
		{	
			if {[.win$id.icons.can index [lindex [.win$id.icons.can gettags $tg] 0] end] > 14}\
			{	
				.win$id.icons.can dchars $tg 12 end
				.win$id.icons.can insert $tg end >>
			}
		}
		.win$id.icons.can configure \
			-scrollregion [.win$id.icons.can bbox all]
		.win$id.icons.can xview moveto 0
		keylset listwindows $id.title [pwd]
		keylset listwindows $id.old [pwd]
		wm title .win$id [pwd]
		if {[.menuBar.window.m type last] == "command"}\
		{
			.menuBar.window.m delete 3 last
			foreach key [keylget listwindows]\
			{	.menuBar.window.m add command \
					-label [keylget listwindows $key.title]\
					-command "raise .win$key
						focus .win$key"
			}
			foreach i [keylget listwindows]\
			{
				.win$i.menuBar.window.m delete 3 last
				foreach key [keylget listwindows]\
				{	.win$i.menuBar.window.m add command \
						-label [keylget listwindows $key.title]\
						-command "raise .win$key
							focus .win$key"
				}
			}	
		}
		popd
	}
}

proc _closeWindow {id}\
{
	global listwindows
	catch {destroy .win$id
		destroy .win$id"icon"}
	keyldel listwindows $id
	if {[.menuBar.window.m type last] == "command"}\
	{
		.menuBar.window.m delete 3 last
		foreach key [keylget listwindows]\
		{	.menuBar.window.m add command \
				-label [keylget listwindows $key.title]\
				-command "raise .win$key
					focus .win$key"
		}
		foreach i [keylget listwindows]\
		{
			.win$i.menuBar.window.m delete 3 last
			foreach key [keylget listwindows]\
			{	.win$i.menuBar.window.m add command \
					-label [keylget listwindows $key.title]\
					-command "raise .win$key
						focus .win$key"
			}
		}	
	}
}


proc _closeAllWindows {}\
{
	global listwindows numwindow
	if {[.menuBar.window.m type last] == "command"}\
	{
		foreach id [keylkeys listwindows]\
		{
			catch {destroy .win$id
				destroy .win$id"icon"}
			keyldel listwindows $id
		}
		.menuBar.window.m delete 3 last
	}
	set numwindow 0
}






